'*******************************************************************************
'*                             TAnimate.bi                                     *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "menus.bi"
#include once "graphics.bi"

#ifndef TAnimateClass
       #define TAnimateClass(__Ptr__) *Cast(TAnimate ptr,__Ptr__)
#endif

#ifndef GetAnimate
       #define GetAnimate(__HWND__) *Cast(TAnimate Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

enum TCommonAVI
    aviNone          = 0
    aviFindFolder    = 150
    aviFindFile      = 151
    aviFindComputer  = 152
    aviCopyFiles     = 160
    aviCopyFile      = 161
    aviRecycleFile   = 162
    aviEmptyRecycle  = 163
    aviDeleteFile    = 164
    aviDownloadFiles = 170
end enum

type PAnimate as TAnimate ptr
type TAnimate
    private:
    AControl       as TControl = TControl("TAnimate","SysAnimate32")
    FFrameCount    as integer
    FFrameWidth    as integer
    FFrameHeight   as integer
    FStartFrame    as integer
    FStopFrame     as integer=-1 
    FAutoSize      as integer
    FRepeat        as integer=-1 
    FCommonAvi     as integer
    FOpen          as integer
    FPlay          as integer
    FAutoPlay      as integer
    FTransparent   as integer
    FCenter        as integer
    FTimers        as integer
    FFile          as string
    FShell32       as hmodule
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    declare sub GetAminateInfo
    public:
    PopupMenu      as TPopupMenu
    Cursor         as TCursor
    Tag            as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TAnimate",ClassAncestor as string = "SysAnimate32")
    declare property Center as integer
    declare property Center(Value as integer)
    declare property Transparency as integer
    declare property Transparency(Value as integer)
    declare property Timers as integer
    declare property Timers(Value as integer)
    declare property File as string
    declare property File(Value as string)
    declare property AutoPlay as integer
    declare property AutoPlay(Value as integer)
    declare property AutoSize as integer
    declare property AutoSize(Value as integer)
    declare property CommonAvi as integer
    declare property CommonAvi(Value as integer)
    declare property Repeat as integer
    declare property Repeat(Value as integer)
    declare property StartFrame as integer
    declare property StartFrame(Value as integer)
    declare property StopFrame as integer
    declare property StopFrame(Value as integer)
    declare property FrameCount as integer
    declare property FrameCount(Value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub Open
    declare sub Play
    declare sub Stop
    declare sub Close
    declare sub BringToFront
    declare sub ClientToScreen(byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    OnOpen  as sub(byref Sender as TAnimate)
    OnClose as sub(byref Sender as TAnimate)
    OnStart as sub(byref Sender as TAnimate) 
    OnStop  as sub(byref Sender as TAnimate)  
end type
