'*******************************************************************************
'*                             Application.bi                                  *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "windows.bi"
#include once "control.bi"
#include once "graphics.bi"

namespace ApplicationObject

     type TApplication
         private:
         FHelpFile        as zstring ptr
         FMainWindow      as hwnd
         FMDIClientHandle as hwnd
         FAccelTable      as haccel
         declare static function EnumThreadWindowsProc(FWindow as hwnd,LData as lparam) as integer
         declare sub EnumControls(Control as TControl)
         declare sub UpdateControlList
         public:
         declare operator cast as any ptr
         declare operator cast as string
         declare property MainWindow as hwnd
         declare property MainWindow(value as hwnd)
         declare property MDIClientHandle as hwnd
         declare property MDIClientHandle(value as hwnd)
         declare property ExeName as string
         declare property ExeName(value as string)
         declare property HelpFile as string
         declare property HelpFile(value as string)
         declare property Title as string
         declare property Title(value as string) 
         declare sub HelpCommand(CommandID as integer,FData as long)
         declare sub HelpContext(ContextID as long)
         declare sub HelpJump(TopicID as string)
         declare sub DoEvents
         declare sub Run 
         declare sub Terminate
         onMessage as sub(byref message as TMessage)
     end type
     
     common shared as TApplication Application
     common shared as TMessage GlobalMessage
end namespace
