'*******************************************************************************
'*                           TButton.bi                                        *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                           version 2.0                                       *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TButtonClass
#define TButtonClass(__Ptr__) *cast(TButton Ptr,__Ptr__)
#endif

#ifndef GetButton
#define GetButton(__HWND__) *cast(TButton Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PButton as TButton ptr
type TButton
    private:
    AControl as TControl=TControl("TButton","Button")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(FWindow as hWnd,Msg as UInt,wparam as wParam,lparam as lParam) as LResult
    public:
    Cursor    as TCursor
    Font      as TFont
    PopupMenu as TPopupMenu
    Tag       as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string="TButton",ClassAncestor as string="Button")
    declare property Caption as String
    declare property Caption(value as String)
    declare property Align as Integer
    declare property Align(value as Integer)
    declare property ClientHeight as Integer
    declare property ClientHeight(value as Integer)
    declare property ClientWidth as Integer
    declare property ClientWidth(value as Integer)
    declare property Color as Integer
    declare property Color(value as Integer)
    declare property Enabled as Integer
    declare property Enabled(value as Integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as Integer
    declare property Height(value as Integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as Integer
    declare property Left(value as Integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as Integer
    declare property ShowHint(value as Integer)
    declare property Top as Integer
    declare property Top(value as Integer)
    declare property TabOrder as Integer
    declare property TabOrder(value as Integer)
    declare property TabStop as Integer
    declare property TabStop(value as Integer)
    declare property Visible as Integer
    declare property Visible(value as Integer)
    declare property Width as Integer
    declare property Width(value as Integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    declare sub Click
    onClick as sub(Byref Sender as TButton)
end type
