'*******************************************************************************
'*                             Classes.bi                                      *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#define TListClass(__Ptr__) *cast(TList ptr,__Ptr__)
#define TStringListClass(__Ptr__) *cast(TStringList ptr,__Ptr__)

type PList as TList ptr
type TList
    private:
    FCount as integer
    FItems as any ptr ptr
    public:
    Declare Property Count as integer
    declare Property Count(value as integer)
    declare property Item(Index as integer) as any ptr
    declare property Item(Index as integer,value as any ptr)
    declare sub Add(value as any ptr)
    declare sub Insert(Index as integer,value as any ptr)
    declare sub Remove overload(value as any ptr)
    declare sub Remove(Index as integer)
    declare sub Exchange(Index1 as integer,Index2 as integer)
    declare function IndexOf(Item as any ptr) as integer
    declare sub Clear
    declare operator cast as any ptr
    declare operator cast as string
    declare constructor
    declare destructor
end type

type PStringList as TStringList ptr
type TStringList
    private:
    FCount  as integer
    FItems  as zstring ptr ptr
    FText   as string 
    public:
    declare property Count as integer
    declare property Count(value as integer)
    declare property Item(Index as integer) as string
    declare property Item(Index as integer,value as string)
    declare property Text as string 
    declare property Text(value as string)
    declare sub Add(value as string)
    declare sub Insert(Index as integer,value as string)
    declare sub Remove(Index as integer)
    declare sub Exchange(Index1 as integer,Index2 as integer)
    declare function IndexOf(value as string) as integer
    declare sub Clear
    declare sub Sort
    declare sub LoadFromFile(File as string)
    declare sub SaveToFile(File as string)
    declare operator cast as any ptr
    declare operator cast as string
    declare constructor
    declare destructor
end type
