'*******************************************************************************
'*                             TComboBox.bi                                    *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"
#include once "ListItem.bi"

#ifndef TEditClass
       #define TEditClass(__Ptr__) *Cast(TComboBox ptr,__Ptr__)
#endif

#ifndef GetComboBox
       #define GetComboBox(__HWND__) *Cast(TAnimate Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PComboBox as TComboBox ptr
type TComboBox
    private:
    AControl as TControl=TControl("TComboBox","ComboBox")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    FIntegralHeight as integer
    FDropdown       as integer
    FItemCount      as integer
    FItems          as TListItem ptr ptr
    FTopIndex       as integer
    FItemIndex      as integer
    FItemHeight     as integer
    FStyle          as integer
    FSorted         as integer
    FCount          as integer
    public:
    Font            as TFont
    PopupMenu       as TPopupMenu
    Cursor          as TCursor
    Tag             as any ptr
    declare Constructor
    declare Destructor
    declare Operator cast as any ptr
    declare Operator cast as TControl
    declare static sub RegisterClass(ClassName as string="TComboBox",ClassAncestor as string="ComboBox")
    declare sub Add(value as string,AObject as any ptr=0)
    declare sub Insert(index as integer,value as string,AObject as any ptr=0)
    declare sub Remove(index as integer)
    declare function IndexOf(value as string) as integer
    declare function IndexOfObject(value as any ptr) as integer
    declare sub Clear
    declare property Sorted as integer
    declare property Sorted(value as integer)
    declare property Style as integer
    declare property Style(value as integer)
    declare property Text as string
    declare property Text(value as string)
    declare property Count as integer
    declare property Count(value as integer)
    declare property IntegralHeight as integer
    declare property IntegralHeight(value as integer)
    declare property TopIndex as integer
    declare property TopIndex(value as integer)
    declare property ItemIndex as integer
    declare property ItemIndex(value as integer)
    declare property ItemHeight as integer
    declare property ItemHeight(value as integer)
    declare property Dropdown as integer
    declare property Dropdown(value as integer)
    declare property Item(index as integer) as string
    declare property Item(index as integer,value as string)
    declare property ItemData(index as integer) as any ptr
    declare property ItemData(index as integer,value as any ptr)
    declare property Align as Integer
    declare property Align(value as Integer)
    declare property ClientHeight as Integer
    declare property ClientHeight(value as Integer)
    declare property ClientWidth as Integer
    declare property ClientWidth(value as Integer)
    declare property Color as Integer
    declare property Color(value as Integer)
    declare property Enabled as Integer
    declare property Enabled(value as Integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as Integer
    declare property Height(value as Integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as Integer
    declare property Left(value as Integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as Integer
    declare property ShowHint(value as Integer)
    declare property Top as Integer
    declare property Top(value as Integer)
    declare property TabOrder as Integer
    declare property TabOrder(value as Integer)
    declare property TabStop as Integer
    declare property TabStop(value as Integer)
    declare property Visible as Integer
    declare property Visible(value as Integer)
    declare property Width as Integer
    declare property Width(value as Integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    onClick       as sub(byref Sender as TComboBox)
    onDblClick    as sub(byref Sender as TComboBox)
    onEditChange  as sub(byref Sender as TComboBox)
    onChange      as sub(byref Sender as TComboBox)
    onDropDown    as sub(byref Sender as TComboBox)
    onCloseUp     as sub(byref Sender as TComboBox)
    onDrawItem    as sub(byref Sender as TComboBox,Index as integer,State as integer,R as rect,Dc as hdc)
    onMeasureItem as sub(byref Sender as TComboBox,Index as integer,byref Height as integer)
end type
