'*******************************************************************************
'*                             TDialog.bi                                        *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "sysutils.bi"
#include once "idesigner.bi"
#include once "control.bi"
#include once "controlcanvas.bi"
#include once "menus.bi"
#include once "graphics.bi"

#ifndef TDialogClass
#define TDialogClass(__Ptr__) *cast(TDialog ptr,__Ptr__)
#endif

#ifndef GeTDialog
#define GeTDialog(__HWND__) *Cast(TDialog Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PDialog as TDialog ptr
type TDialog
    private:
    AControl         as TControl=TControl("TDialog")
    FDeferPtr        as hdwp
    FMain            as integer
    FWindowState     as integer
    FShowModal       as integer
    FAlphaBlend      as integer
    FAlphaValue      as integer
    FKeyPreview      as integer
    FBorderStyle     as integer
    FFormStyle       as integer
    FCenter          as integer
    FDesigner        as PDesigner
    declare static function EnumAppWindowsProc(FWindow as hwnd,lData as lparam) as integer
    declare static sub IconChanged(byref Icon as TIcon)
    declare static sub FontChanged(byref Font as TFont)
    declare sub CreateTemplate
    declare sub DisableTaskList
    declare sub EnableTaskList
    declare sub SetSysMenu
    declare sub SendCancelMode(AControl as TControl ptr)
    declare sub DispatchMessage(byref Message as TMessage)
    declare sub ProcessMessage(byref Message as TMessage)
    declare sub ProcessDesignMessage(byref Message as TMessage)
    declare static function DlgProc(FWindow as hwnd,msg as UInt,wparam as wParam,lparam as lParam) as integer
    declare static function WindowProc(FWindow as hwnd,msg as UInt,wparam as wParam,lparam as lParam) as integer
    public:
    IsModal          as integer
    Canvas           as TControlCanvas
    Menu             as TMenu
    PopupMenu        as TPopupMenu
    Icon             as TIcon
    Font             as TFont
    Cursor           as TCursor
    ModalResult      as integer
    Result           as integer
    Tag              as any ptr
    declare constructor(AModal as integer=true)
    declare destructor
    declare operator cast as any ptr
    declare operator cast as PControl
    declare operator cast as string
    declare property Designer as PDesigner
    declare property Designer(value as PDesigner)
    declare property BorderStyle as integer
    declare property BorderStyle(value as integer)
    declare property Main as integer
    declare property Main(value as integer)
    declare property Center as integer
    declare property Center(value as integer)
    declare property FormStyle as integer
    declare property FormStyle(value as integer)
    declare property Caption as string
    declare property Caption(value as string)
    declare Property AlphaBlend as integer
    declare Property AlphaBlend(value as integer)
    declare Property AlphaBlendValue as integer
    declare Property AlphaBlendValue(value as integer)
    declare Property KeyPreview as integer
    declare Property KeyPreview(value as integer)
    declare Property WindowState as integer
    declare Property WindowState(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property ParentWindow as hwnd
    declare property ParentWindow(value as hwnd)
    declare property ActiveControl as PControl
    declare property ActiveControl(value as PControl)
    declare property Parent as PControl
    declare property Parent(value as PControl)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property ControlCount as integer
    declare property ControlCount(value as integer)
    declare property Control(index as integer) as PControl
    declare property Control(index as integer,value as PControl)
    declare property DesignMode as integer
    declare property DesignMode(value as integer)
    declare function IndexOf(value as PControl) as integer
    declare static sub RegisterClass(byref AClassName as string="TDialog")
    declare sub Show
    declare sub Hide
    declare sub Close
    declare function ShowModal as integer
    declare sub ClientToScreen(byref P as Point)
    declare sub ScreenToClient(byref P as Point)
    declare sub Repaint
    declare sub Invalidate
    declare sub Update
    declare sub BringToFront
    declare sub SendToBack
    declare sub SetFocus
    onCreate     as sub(byref Sender as TDialog)
    onPaint      as sub(byref Sender as TDialog,dc as hdc)
    onClose      as sub(byref Sender as TDialog,byref CloseAction as integer)
    onCommand    as sub(byref Sender as TDialog,id as integer,code as integer)
    onActivate   as sub(byref Sender as TDialog)
    onDeActivate as sub(byref Sender as TDialog)
    onResize     as sub(byref Sender as TDialog)
    onShow       as sub(byref Sender as TDialog)
    onHide       as sub(byref Sender as TDialog)
    onTimer      as sub(byref Sender as TDialog,timerid as integer,TimerProc as any ptr=0)
    onScroll     as sub(byref Sender as TDialog,code as integer,byref scrollpos as integer)
    onMouseDown  as sub(byref Sender as TDialog,mousebutton as integer,x as integer,y as integer,shift as integer)
    onMouseUp    as sub(byref Sender as TDialog,mousebutton as integer,x as integer,y as integer,shift as integer)
    onMouseMove  as sub(byref Sender as TDialog,x as integer,y as integer,shift as integer)
    onMousewheel as sub(byref Sender as TDialog,direction as integer,x as integer,y as integer,shift as integer)
    onKeyPress   as sub(byref Sender as TDialog,key as byte)
    onKeyDown    as sub(byref Sender as TDialog,key as word,shift as integer)
    onKeyUp      as sub(byref Sender as TDialog,key as word,shift as integer)
end type
