'*******************************************************************************
'*                             TEdit.bi                                        *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"

#ifndef TEditClass
       #define TEditClass(__Ptr__) *Cast(TEdit ptr,__Ptr__)
#endif

#ifndef GetEdit
       #define GetEdit(__HWND__) *Cast(TAnimate Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PEdit as TEdit ptr
type TEdit
    private:
    AControl   as TControl = TControl("TEdit","Edit")
    FAlignment as integer
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    public:
    Font       as TFont
    Tag        as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TEdit",ClassAncestor as string = "Edit")
    declare Property ReadOnly as integer
    declare Property ReadOnly(value as integer)
    declare Property PasswordChar as string
    declare Property PasswordChar(value as string)
    declare Property Masked as integer
    declare Property Masked(value as integer)
    declare Property NumberOnly as integer
    declare Property NumberOnly(value as integer)
    declare Property CharCase as integer
    declare Property CnarCase(value as integer)
    declare Property SelText as string
    declare Property SelText(value as string)
    declare Property SelStart as integer
    declare Property SelStart(value as integer)
    declare Property SelLength as integer
    declare Property SelLength(value as integer)
    declare Property Text as string
    declare Property Text(value as string)
    declare Property Alignment as Integer
    declare Property Alignment(value as Integer)
    declare Property Align as Integer
    declare Property Align(value as Integer)
    declare Property ClientHeight as Integer
    declare Property ClientHeight(value as Integer)
    declare Property ClientWidth as Integer
    declare Property ClientWidth(value as Integer)
    declare Property Color as Integer
    declare Property Color(value as Integer)
    declare Property Enabled as Integer
    declare Property Enabled(value as Integer)
    declare Property Handle as hwnd
    declare Property Handle(value as hwnd)
    declare Property Height as Integer
    declare Property Height(value as Integer)
    declare Property Hint as String
    declare Property Hint(value as String)
    declare Property Left as Integer
    declare Property Left(value as Integer)
    declare Property Parent as TControl ptr
    declare Property Parent(value as TControl ptr)
    declare Property ShowHint as Integer
    declare Property ShowHint(value as Integer)
    declare Property Top as Integer
    declare Property Top(value as Integer)
    declare Property Visible as Integer
    declare Property Visible(value as Integer)
    declare Property Width as Integer
    declare Property Width(value as Integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    onChange as sub(byref Sender as TEdit)
end type
