'*******************************************************************************
'*                             THeaderControl.bi                               *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"


#ifndef THeaderControlClass
       #define THeaderControlClass(__Ptr__) *Cast(TTHeaderControl ptr,__Ptr__)
#endif

#ifndef GetHeaderControl
       #define GetHeaderControl(__HWND__) *Cast(TTHeaderControl Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif


type PHeader as THeaderControl ptr

type THeaderSection
    private:
    FCaption      as string
    FAlignment    as integer
    FImageIndex   as integer
    FStyle        as integer
    FWidth        as integer
    public:
    HeaderControl as PHeader
    Tag           as Any Ptr
    declare property Caption as string
    declare property Caption(Value as string)
    declare property Alignment as integer
    declare property Alignment(Value as integer)
    declare property ImageIndex as integer
    declare property ImageIndex(Value as integer)
    declare property Width as integer
    declare property Width(Value as integer)
    declare property Style as integer
    declare property Style(Value as integer)
    declare operator cast as Any Ptr
    declare operator cast as string
    declare constructor
    declare destructor
End type

type THeaderControl
    private:
    AControl       as TControl = TControl("THeaderControl","SysHeader32")
    FStyle         as integer
    FFullDrag      as integer
    FDragReorder   as integer
    FHotTrack      as integer
    FSectionCount  as integer
    FSections      as THeaderSection ptr ptr
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    public:
    Images         as TImageList
    Font           as TFont
    PopupMenu      as TPopupMenu
    Tag            as any ptr
    declare Constructor
    declare Destructor
    declare Operator cast as any ptr
    declare Operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "THeaderControl",ClassAncestor as string = "SysHeader32")
    declare property Style as integer
    declare property Style(Value as integer)
    declare property HotTrack as integer
    declare property HotTrack(Value as integer)
    declare property FullDrag as integer
    declare property FullDrag(Value as integer)
    declare property DragReorder as integer
    declare property DragReorder(Value as integer)
    declare property SectionCount as integer
    declare property SectionCount(Value as integer)
    declare property Section(Index as integer) as THeaderSection Ptr
    declare property Section(Index as integer,Value as THeaderSection Ptr)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as string
    declare property Hint(value as string)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub AddSection(FCaption as string="",FImageIndex as integer=-1,FWidth as integer=50,FAlignment as integer=0)
    declare sub InsertSection(FIndex as integer,FCaption as string="",FImageIndex as integer=-1,FWidth as integer=50,FAlignment as integer=0)
    declare sub AddSections cdecl(FCount as integer,...)
    declare sub RemoveSection(Index as integer)
    declare sub Clear
    declare function IndexOfSection(value as THeaderSection ptr) as integer
    declare sub UpdateItems
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    OnSectionClick    as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection,Index as integer,MouseButton as integer)
    OnSectionDblClick as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection,Index as integer,MouseButton as integer)
    OnChange          as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection)
    OnChanging        as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection)
    OnBeginTrack      as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection) 
    OnEndTrack        as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection)
    OnTrack           as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection)
    OnDividerDblClick as sub(Byref Sender as THeaderControl,Index as integer,MouseButton as integer)
    OnDrawSection     as sub(Byref Sender as THeaderControl,Byref Section as THeaderSection, R as Rect, State as integer)
end type
