'*******************************************************************************
'*                             TListBox.bi                                     *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "graphics.bi"
#include once "menus.bi"
#include once "control.bi"
#include once "listitem.bi"

#ifndef TListBoxClass
       #define TListBoxClass(__Ptr__) *Cast(TListBox ptr,__Ptr__)
#endif

#ifndef GetListBox
       #define GetListBox(__HWND__) *Cast(TListBox Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PListBos as TListBox ptr
type TListBox
    private:
    AControl as TControl=TControl("TListBox","ListBox")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    FItemIndex      as integer
    FItemHeight     as integer
    FTopIndex       as integer
    FColumns        as integer
    FColumnWidth    as integer
    FStyle          as integer
    FSelCount       as integer
    FSelected       as integer ptr
    FMultipleSel    as integer
    FHideSel        as integer
    FSorted         as integer
    FIntegralHeight as integer
    FCount          as integer 
    FItems          as TlistItem ptr ptr
    public:
    Font            as TFont
    PopupMenu       as TPopupMenu
    Cursor          as TCursor
    Tag             as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string="TListBox",ClassAncestor as string="ListBox")
    declare sub Add(value as string,AObject as any ptr)
    declare sub Insert(index as integer,value as string,AObject as any ptr)
    declare sub Remove(index as integer)
    declare function IndexOf(value as string) as integer
    declare function IndexOfObject(value as any ptr) as integer
    declare sub Clear
    declare property ItemHeight as integer
    declare property ItemHeight(value as integer)
    declare property IntegralHeight as integer
    declare property IntegralHeight(value as integer)
    declare property Sorted as integer
    declare property Sorted(value as integer)
    declare property HideSelection as integer
    declare property HideSelection(value as integer)
    declare property MultipleSelection as integer
    declare property MultipleSelection(value as integer)
    declare property Selected(index as integer) as integer
    declare property Selected(index as integer,value as integer)
    declare property Columns as integer
    declare property Columns(value as integer)
    declare property ColumnWidth as integer
    declare property ColumnWidth(value as integer)
    declare property Style as integer
    declare property Style(value as integer)
    declare property Count as integer
    declare property Count(value as integer)
    declare property TopIndex as integer
    declare property TopIndex(value as integer)
    declare property ItemIndex as integer
    declare property ItemIndex(value as integer)
    declare property Item(index as integer) as string
    declare property Item(index as integer,value as string)
    declare property ItemData(index as integer) as any ptr
    declare property ItemData(index as integer,value as any ptr)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as string
    declare property Hint(value as string)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property TabOrder as Integer
    declare property TabOrder(value as Integer)
    declare property TabStop as Integer
    declare property TabStop(value as Integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    onClick       as sub(byref Sender as TListBox)
    onDblClick    as sub(byref Sender as TListBox)
    onChange      as sub(byref Sender as TListBox)
    onDrawItem    as sub(byref Sender as TListBox,Index as integer,State as integer,R as rect,Dc as hdc)
    onMeasureItem as sub(byref Sender as TListBox,Index as integer,byref Height as integer)
    onEraseBkGnd  as sub(byref Sender as TListBox,Dc as hdc,R as Rect)
end type
