'*******************************************************************************
'*                             TMDIForm.bi                                     *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "sysutils.bi"
#include once "idesigner.bi"
#include once "control.bi"
#include once "controlcanvas.bi"
#include once "menus.bi"
#include once "graphics.bi"

#ifndef TMDIFormClass
#define TMDIFormClass(__Ptr__)  *cast(TMDIForm ptr,__Ptr__)
#endif

#ifndef TMDIChildClass
#define TMDIChildClass(__Ptr__) *cast(TMDIChild ptr,__Ptr__)
#endif

#ifndef GeTMDIForm
#define GeTMDIForm(__HWND__)  *Cast(TMDIForm Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

#ifndef GetMDIChild
#define GetMDIChild(__HWND__) *Cast(TMDIChild Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PMDIChild as TMDIChild ptr
type TMDIChild
    private:
    AControl         as TControl=TControl("TMDIChild")
    FMain            as integer
    FWindowState     as integer
    FShowModal       as integer
    FAlphaBlend      as integer
    FAlphaValue      as integer
    FKeyPreview      as integer
    FBorderStyle     as integer
    FFormStyle       as integer
    FDesigner        as PDesigner
    declare static sub IconChanged(byref Icon as TIcon)
    declare static sub FontChanged(byref Font as TFont)
    declare sub SetSysMenu
    declare sub SendCancelMode(AControl as TControl ptr)
    declare sub DispatchMessage(byref Message as TMessage)
    declare sub ProcessMessage(byref Message as TMessage)
    declare sub ProcessDesignMessage(byref Message as TMessage)
    declare sub MsgDefault(byref Message as TMessage)
    declare Static Function WindowProc(FWindow as hwnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    public:
    Canvas           as TControlCanvas
    Menu             as TMenu
    PopupMenu        as TPopupMenu
    Icon             as TIcon
    Font             as TFont
    Cursor           as TCursor
    ModalResult      as integer
    Tag              as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as PControl
    declare operator cast as string
    declare property Designer as PDesigner
    declare property Designer(value as PDesigner)
    declare property BorderStyle as integer
    declare property BorderStyle(value as integer)
    declare property Caption as string
    declare property Caption(value as string)
    declare Property AlphaBlend as integer
    declare Property AlphaBlend(value as integer)
    declare Property AlphaBlendValue as integer
    declare Property AlphaBlendValue(value as integer)
    declare Property KeyPreview as integer
    declare Property KeyPreview(value as integer)
    declare Property WindowState as integer
    declare Property WindowState(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property ParentWindow as hwnd
    declare property ParentWindow(value as hwnd)
    declare property ActiveControl as TControl ptr
    declare property ActiveControl(value as TControl ptr)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property ControlCount as integer
    declare property ControlCount(value as integer)
    declare property Control(index as integer) as TControl ptr
    declare property Control(index as integer,value as TControl ptr)
    declare property DesignMode as integer
    declare property DesignMode(value as integer)
    declare function IndexOf(value as TControl ptr) as integer
    declare static sub RegisterClass(byref AClassName as string="TMDIChild")
    declare sub Show
    declare sub Hide
    declare sub Close
    declare sub ClientToScreen(byref P as Point)
    declare sub ScreenToClient(byref P as Point)
    declare sub Repaint
    declare sub Invalidate
    declare sub Update
    declare sub BringToFront
    declare sub SendToBack
    declare sub SetFocus
    onCreate     as sub(byref Sender as TMDIChild)
    onPaint      as sub(byref Sender as TMDIChild,dc as hdc)
    onclose      as sub(byref Sender as TMDIChild,byref CloseAction as integer)
    onCommand    as sub(byref Sender as TMDIChild,id as integer,code as integer)
    onActivate   as sub(byref Sender as TMDIChild)
    onDeActivate as sub(byref Sender as TMDIChild)
    onResize     as sub(byref Sender as TMDIChild)
    onShow       as sub(byref Sender as TMDIChild)
    onHide       as sub(byref Sender as TMDIChild)
    onTimer      as sub(byref Sender as TMDIChild,timerid as integer,TimerProc as any ptr=0)
    onScroll     as sub(byref Sender as TMDIChild,code as integer,byref scrollpos as integer)
    onMouseDown  as sub(byref Sender as TMDIChild,mousebutton as integer,x as integer,y as integer,shift as integer)
    onMouseUp    as sub(byref Sender as TMDIChild,mousebutton as integer,x as integer,y as integer,shift as integer)
    onMouseMove  as sub(byref Sender as TMDIChild,x as integer,y as integer,shift as integer)
    onMousewheel as sub(byref Sender as TMDIChild,direction as integer,x as integer,y as integer,shift as integer)
    onKeyPress   as sub(byref Sender as TMDIChild,key as byte)
    onKeyDown    as sub(byref Sender as TMDIChild,key as word,shift as integer)
    onKeyUp      as sub(byref Sender as TMDIChild,key as word,shift as integer)
end type

type PMDIForm as TMDIForm ptr
type TMDIForm
    private:
    AControl         as TControl=TControl("TMDIForm")
    FDeferPtr        as hdwp
    FMain            as integer
    FWindowState     as integer
    FShowModal       as integer
    FAlphaBlend      as integer
    FAlphaValue      as integer
    FKeyPreview      as integer
    FBorderStyle     as integer
    FFormStyle       as integer
    FCenter          as integer
    FDesigner        as PDesigner
    FActiveChildForm as TMDIChild ptr
    FWindowMenu      as TMenuItem ptr
    declare static function EnumAppWindowsProc(FWindow as hwnd,lData as lparam) as integer
    declare static sub IconChanged(byref Icon as TIcon)
    declare static sub FontChanged(byref Font as TFont)
    declare sub DisableTaskList
    declare sub EnableTaskList
    declare sub SetSysMenu
    declare sub SendCancelMode(AControl as TControl ptr)
    declare sub DispatchMessage(byref Message as TMessage)
    declare sub ProcessMessage(byref Message as TMessage)
    declare sub ProcessDesignMessage(byref Message as TMessage)
    declare sub MsgDefault(byref Message as TMessage)
    declare static function WindowProc(FWindow as hwnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    public:
    ModalResult      as integer
    MDIClient        as TControl
    Canvas           as TControlCanvas
    Menu             as TMenu
    PopupMenu        as TPopupMenu
    Icon             as TIcon
    Font             as TFont
    Cursor           as TCursor
    Tag              as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as PControl
    declare operator cast as string
    declare property Designer as PDesigner
    declare property Designer(value as PDesigner)
    declare property WindowMenu as TMenuItem ptr
    declare property WindowMenu(value as TMenuItem ptr)
    declare property BorderStyle as integer
    declare property BorderStyle(value as integer)
    declare property Main as integer
    declare property Main(value as integer)
    declare property Center as integer
    declare property Center(value as integer)
    declare property FormStyle as integer
    declare property FormStyle(value as integer)
    declare property Caption as string
    declare property Caption(value as string)
    declare property AlphaBlend as integer
    declare property AlphaBlend(value as integer)
    declare property AlphaBlendValue as integer
    declare property AlphaBlendValue(value as integer)
    declare property KeyPreview as integer
    declare property KeyPreview(value as integer)
    declare property WindowState as integer
    declare property WindowState(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property ParentWindow as hwnd
    declare property ParentWindow(value as hwnd)
    declare property ActiveControl as TControl ptr
    declare property ActiveControl(value as TControl ptr)
    declare property ActiveChildForm as TMDIChild ptr
    declare property ActiveChildForm(value as TMDIChild ptr)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property ControlCount as integer
    declare property ControlCount(value as integer)
    declare property Control(index as integer) as TControl ptr
    declare property Control(index as integer,value as TControl ptr)
    declare property DesignMode as integer
    declare property DesignMode(value as integer)
    declare function IndexOf(value as TControl ptr) as integer
    declare static sub RegisterClass(byref AClassName as string="TMDIForm")
    declare sub RefreshMDIMenu
    declare sub RefreshWindowMenu
    declare sub ArrangeIcons
    declare sub TileHorizontal
    declare sub TileVertical
    declare sub Cascade
    declare sub Show
    declare sub Hide
    declare sub Close
    declare sub RestoreActive
    declare sub CloseActive
    declare sub MinimizeActive
    declare sub MaximizeActive
    declare sub RestoreAll
    declare sub CloseAll
    declare sub MinimizeAll
    declare sub MaximizeAll
    declare function ShowModal as integer
    declare sub ClientToScreen(byref P as Point)
    declare sub ScreenToClient(byref P as Point)
    declare sub Repaint
    declare sub Invalidate
    declare sub Update
    declare sub BringToFront
    declare sub SendToBack
    declare sub SetFocus
    onCreate      as sub(byref Sender as TMDIForm)
    onPaint       as sub(byref Sender as TMDIForm,dc as hdc)
    onclose       as sub(byref Sender as TMDIForm,byref CloseAction as integer)
    onCommand     as sub(byref Sender as TMDIForm,id as integer,code as integer)
    onActivate    as sub(byref Sender as TMDIForm)
    onDeActivate  as sub(byref Sender as TMDIForm)
    onResize      as sub(byref Sender as TMDIForm)
    onShow        as sub(byref Sender as TMDIForm)
    onHide        as sub(byref Sender as TMDIForm)
    onTimer       as sub(byref Sender as TMDIForm,timerid as integer,TimerProc as any ptr=0)
    onScroll      as sub(byref Sender as TMDIForm,code as integer,byref scrollpos as integer)
    onMouseDown   as sub(byref Sender as TMDIForm,mousebutton as integer,x as integer,y as integer,shift as integer)
    onMouseUp     as sub(byref Sender as TMDIForm,mousebutton as integer,x as integer,y as integer,shift as integer)
    onMouseMove   as sub(byref Sender as TMDIForm,x as integer,y as integer,shift as integer)
    onMousewheel  as sub(byref Sender as TMDIForm,direction as integer,x as integer,y as integer,shift as integer)
    onKeyPress    as sub(byref Sender as TMDIForm,key as byte)
    onKeyDown     as sub(byref Sender as TMDIForm,key as word,shift as integer)
    onKeyUp       as sub(byref Sender as TMDIForm,key as word,shift as integer)
end type
