'*******************************************************************************
'*                             TMemo.bas                                       *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"

#define TMemoClass(__Ptr__) *cast(TMemo ptr,__Ptr__)

Type TMemo
    private:
    AControl as TControl = TControl("TMemo","Edit")
    declare Sub DispatchMessage(Byref Message as TMessage)
    declare Sub ProcessMessage(Byref Message as TMessage)
    declare Sub MsgDefault(Byref Message as TMessage)
    declare Static Function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    FScrollBars as integer
    FWordWrap   as integer
    public:
    Font        as TFont
    Tag         as any ptr
    declare Constructor
    declare Destructor
    declare Operator cast as any ptr
    declare Operator cast as TControl ptr
    declare static Sub RegisterClass(ClassName as string = "TMemo",ClassAncestor as string = "Edit")
    declare Sub Add(ALine as string)
    declare Sub Insert(AIndex as integer,ALine as string)
    declare Sub Remove(AIndex as integer)
    declare Sub Clear
    declare Sub Undo
    declare Sub PasteFromClipboard
    declare Sub CopyToClipboard
    declare Sub CutToClipboard
    declare Sub SelectAll
    declare Sub LoadFromFile(File as string)
    declare Sub SaveToFile(File as string)
    declare Property ReadOnly as integer
    declare Property ReadOnly(value as integer)
    declare Property Lines(Index as integer) as string
    declare Property Lines(Index as integer,value as string)
    declare Property Count as Integer
    declare Property Count(value as Integer)
    declare Property CaretPos as Point
    declare Property CaretPos(value as Point)
    declare Property Text as string
    declare Property Text(value as string)
    declare Property SelText as string
    declare Property SelText(value as string)
    declare Property SelStart as integer
    declare Property SelStart(value as integer)
    declare Property SelLength as integer
    declare Property SelLength(value as integer)
    declare Property ScrollBars as integer
    declare Property ScrollBars(value as integer)
    declare Property WordWrap as Integer
    declare Property WordWrap(value as Integer)
    declare Property Align as Integer
    declare Property Align(value as Integer)
    declare Property ClientHeight as Integer
    declare Property ClientHeight(value as Integer)
    declare Property ClientWidth as Integer
    declare Property ClientWidth(value as Integer)
    declare Property Color as Integer
    declare Property Color(value as Integer)
    declare Property Enabled as Integer
    declare Property Enabled(value as Integer)
    declare Property Handle as hwnd
    declare Property Handle(value as hwnd)
    declare Property Height as Integer
    declare Property Height(value as Integer)
    declare Property Hint as String
    declare Property Hint(value as String)
    declare Property Left as Integer
    declare Property Left(value as Integer)
    declare Property Parent as TControl ptr
    declare Property Parent(value as TControl ptr)
    declare Property ShowHint as Integer
    declare Property ShowHint(value as Integer)
    declare Property Top as Integer
    declare Property Top(value as Integer)
    declare Property Visible as Integer
    declare Property Visible(value as Integer)
    declare Property Width as Integer
    declare Property Width(value as Integer)
    declare Sub BringToFront
    declare Sub ClientToScreen(Byref P as Point)
    declare Sub Invalidate
    declare Sub Repaint
    declare Sub ScreenToClient(Byref P as Point)
    declare Sub SendToBack
    declare Sub SetFocus
    declare Sub Update
    onChange   as Sub(byref Sender as TMemo)
    onKeyPress as Sub(byref Sender as TMemo,Key as byte)
    onKeyDown  as Sub(byref Sender as TMemo,Key as word,Shift as integer)
    onKeyUp    as Sub(byref Sender as TMemo,Key as word,Shift as integer)
end Type
