'*******************************************************************************
'*                             Menus.bi                                        *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "windows.bi"
#include once "win/commctrl.bi"

#include once "graphics.bi"

#ifndef TMenuItemClass
#define TMenuItemClass(__Ptr__)  *cast(TMenuItem ptr,__Ptr__)
#endif

#ifndef TPopupMenuClass
#define TPopupMenuClass(__Ptr__) *cast(TPopupMenu ptr,__Ptr__)
#endif

#ifndef TMenuClass
#define TMenuClass(__Ptr__)      *cast(TMenu ptr,__Ptr__)
#endif

const MIM_BACKGROUND      = &H2
const MIM_APPLYTOSUBMENUS = &H80000000
const MIM_MENUDATA        = &h00000008

type PMenuItem as TMenuItem ptr
type TMenuItem
    private:
    FParent     as TMenuItem ptr
    FCaption    as string
    FChecked    as integer
    FRadioItem  as integer
    FEnabled    as integer
    FVisible    as integer
    FMenuIndex  as integer
    FCount      as integer
    FItems      as TMenuItem ptr ptr
    public:
    ImageIndex as integer
    Menu        as hmenu
    Handle      as hmenu
    Command     as integer
    Tag         as any ptr
    declare sub SetMenuInfo(Byref fInfo as MenuItemInfo)
    declare sub Add(AItem as TMenuItem ptr)
    declare sub Insert(AIndex as integer,AItem as TMenuItem ptr)
    declare sub Remove(AItem as TMenuItem ptr)
    declare function IndexOf(AItem as TMenuItem ptr) as integer
    declare function FindItem(Id as integer) as TMenuItem ptr
    declare Property Caption as string
    declare Property Caption(value as string)
    declare Property Parent as TMenuItem ptr
    declare Property Parent(value as TMenuItem ptr)
    declare Property MenuIndex as integer
    declare Property MenuIndex(value as integer)
    declare Property Checked as Integer
    declare Property Checked(Value as Integer)
    declare Property RadioItem as Integer
    declare Property RadioItem(Value as Integer)
    declare Property Enabled as Integer
    declare Property Enabled(Value as Integer)
    declare Property Visible as Integer
    declare Property Visible(Value as Integer)
    declare Property Count as integer
    declare Property Count(value as integer)
    declare Property Item(index as integer) as TMenuItem ptr
    declare Property Item(index as integer,value as TMenuItem ptr)
    declare sub Click
    declare constructor
    declare destructor
    declare Operator cast as any ptr
    declare Operator cast as string
    onClick as sub(byref Sender as TMenuItem)
End type

type PMenu as TMenu ptr
type TMenu
    private:
    FWindowHandle    as hwnd
    FCount           as integer
    FItems           as TMenuItem ptr ptr
    FIncludeSubItems as integer=1 'change to "0" to not color the items
    FColor           as integer
    FStyle           as integer
    public:
    ImageList        as TImageList
    Font             as TFont
    Handle           as hmenu
    Tag              as any ptr
    declare sub Add(AItem as TMenuItem ptr)
    declare sub Insert(AIndex as integer,AItem as TMenuItem ptr)
    declare sub Remove(AItem as TMenuItem ptr)
    declare function IndexOf(AItem as TMenuItem ptr) as integer
    declare function FindItem(Id as integer) as TMenuItem ptr
    declare Property Style as integer
    declare Property Style(value as integer)
    declare Property Color as integer
    declare Property Color(value as integer)
    declare Property Count as integer
    declare Property Count(value as integer)
    declare Property Item(index as integer) as TMenuItem ptr
    declare Property Item(index as integer,value as TMenuItem ptr)
    declare Property WindowHandle as hwnd
    declare Property WindowHandle(value as hwnd)
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as string
    onActivate as sub(byref Sender as TMenu) 
End type

type PPopupMenu as TPopupMenu ptr
type TPopupMenu
    private:
    FCount       as integer
    FItems       as TMenuItem ptr ptr
    public:
    ImageList    as TImageList
    Font         as TFont
    Style        as integer
    Handle       as hmenu
    WindowHandle as hwnd
    Tag          as any ptr
    declare sub Add(AItem as TMenuItem ptr)
    declare sub Insert(AIndex as integer,AItem as TMenuItem ptr)
    declare sub Remove(AItem as TMenuItem ptr)
    declare function IndexOf(AItem as TMenuItem ptr) as integer
    declare function FindItem(Id as integer) as TMenuItem ptr
    declare sub Popup(x as integer,y as integer)
    declare Property Count as integer
    declare Property Count(value as integer)
    declare Property Item(index as integer) as TMenuItem ptr
    declare Property Item(index as integer,value as TMenuItem ptr)
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as string
    onDropDown as sub(byref sender as TPopupMenu)
End type
