'*******************************************************************************
'*                           TPanel.bi                                         *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                           version 2.0                                       *
'*******************************************************************************

#include once "control.bi"
#include once "canvas.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TPanelClass
#define TPanelClass(__Ptr__) *cast(TPanel Ptr,__Ptr__)
#endif

#ifndef GetPanel
#define GetPanel(__HWND__) *cast(TPanel Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

enum TBevel
     bvNone=0,bvLowered,bvRaised
end enum 

type PPanel as TPanel ptr
type TPanel
    private:
    AControl        as TControl = TControl("TPanel")
    FTopColor       as integer
    FBottomColor    as integer
    FBevelInner     as integer
    FBevelOuter     as integer
    FBorderWidth    as integer=1
    FBevelWidth     as integer
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    declare sub AdjustColors(FBevel as Integer)
    declare sub DoRect(R as Rect)
    declare sub Frame3D(R as Rect,AWidth as integer)
    public:
    Canvas          as TCanvas
    Cursor          as TCursor
    Font            as TFont
    PopupMenu       as TPopupMenu
    Tag             as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TPanel")
    declare property DoubleBuffered as integer
    declare property DoubleBuffered(Value as integer)
    declare property BevelInner as integer
    declare property BevelInner(Value as integer)
    declare property BevelOuter as integer
    declare property BevelOuter(Value as integer)
    declare property BevelWidth as integer
    declare property BevelWidth(Value as integer)
    declare property BorderWidth as integer
    declare property BorderWidth(Value as integer)
    declare property Caption as string
    declare property Caption(value as string)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as string
    declare property Hint(value as string)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    onClick     as sub(Byref Sender as TPanel)
    OnPaint     as sub(Byref Sender as TPanel,DC As HDC,R As Rect)
    OnSize      as sub(Byref Sender as TPanel)
    OnMouseDown as sub(Byref Sender as TPanel,Button as integer,x as integer,y as integer,Shift as integer)
    OnMouseMove as sub(Byref Sender as TPanel,x as integer,y as integer,Shift as integer)
    OnMouseUp   as sub(Byref Sender as TPanel,Button as integer,x as integer,y as integer,Shift as integer)
end type
