'*******************************************************************************
'*                             TProgressBar.bi                                 *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TProgressBarClass
       #define TProgressBarClass(__Ptr__) *Cast(TProgressBar ptr,__Ptr__)
#endif

#ifndef GetProgressBar
       #define GetProgressBar(__HWND__) *Cast(TProgressBar Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PProgressBar as TProgressBar ptr
type TProgressBar
    private:
    AControl       as TControl = TControl("TProgressBar","msctls_Progress32")
    FMode32        as integer=1 
    FPosition      as integer
    FMinValue      as integer
    FMaxValue      as integer=100
    FStep          as integer=1
    FSmooth        as integer
    FOrientation   as integer
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    declare sub SetRange(AMin as Integer,AMax as Integer)
    public:
    Font           as TFont
    PopupMenu      as TPopupMenu
    Cursor         as TCursor
    Tag            as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TProgressBar",ClassAncestor as string = "msctls_Progress32")
    declare property MinValue as Integer
    declare property MinValue(Value as integer)
    declare property MaxValue as integer
    declare property MaxValue(Value as integer)
    declare property Position as integer
    declare property Position(Value as integer)
    declare property StepValue as integer
    declare property StepValue(Value as integer)
    declare property Smooth as integer
    declare property Smooth(Value as integer)
    declare property Orientation as integer
    declare property Orientation(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub StepIt
    declare sub StepBy(Delta as integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
end type
