'*******************************************************************************
'*                             TScrollBar.bi                                   *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"

#ifndef TScrollBarClass
       #define TScrollBarClass(__Ptr__) *Cast(TScrollBar ptr,__Ptr__)
#endif

#ifndef GetScrollBar
       #define GetScrollBar(__HWND__) *Cast(TScrollBar Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif


enum TScrollBarStyle
    sbHorizontal,sbVertical
end enum

type PScrollBar as TScrollBar ptr
type TScrollBar
    private:
    AControl as TControl = TControl("TScrollBar","ScrollBar")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare Static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    FStyle    as integer
    FMin      as integer
    FMax      as integer 
    FPosition as integer
    FPageSize as integer
    Sif       as ScrollInfo
    public:
    Font      as TFont
    Cursor    as TCursor
    Tag       as any ptr
    declare Constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TScrollBar",ClassAncestor as string = "ScrollBar")
    declare property Style as integer
    declare property Style(value as integer)
    declare property MinValue as integer
    declare property MinValue(value As integer)
    declare property MaxValue as integer
    declare property MaxValue(value as integer)
    declare property PageSize as integer
    declare property PageSize(value as integer)
    declare property Position as integer
    declare property Position(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    OnScroll As sub(Byref Sender As TScrollBar,ScrollCode As integer,Byref ScrollPos As integer)
end type
