'*******************************************************************************
'*                             TStaticText.bi                                  *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TStaticTextClass
       #define TStaticTextClass(__Ptr__) *Cast(TStaticText ptr,__Ptr__)
#endif

#ifndef GetStaticText
       #define GetStaticText(__HWND__) *Cast(TStaticText Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PStaticText as TStaticText ptr  
type TStaticText
    private:
    AControl as TControl = TControl("TStaticText","Static")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare Static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    FTransparent as integer
    FPrefix      as integer=1 
    FAlignment   as integer
    FStyle       as integer
    FBorderStyle as integer
    FWordwrap    as integer=1
    public:
    Font         as TFont
    PopupMenu    as TPopupMenu
    Cursor       as TCursor
    Tag          as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TStaticText",ClassAncestor as string = "Static")
    declare property Alignment as Integer
    declare property Alignment(value as Integer)
    declare property Transparency as Integer
    declare property Transparency(value as Integer)
    declare property Prefix as Integer
    declare property Prefix(value as Integer)
    declare property Style as Integer
    declare property Style(value as Integer)
    declare property BorderStyle as Integer
    declare property BorderStyle(value as Integer)
    declare property Caption as string
    declare property Caption(value as string)
    declare property Align as Integer
    declare property Align(value as Integer)
    declare property ClientHeight as Integer
    declare property ClientHeight(value as Integer)
    declare property ClientWidth as Integer
    declare property ClientWidth(value as Integer)
    declare property Color as Integer
    declare property Color(value as Integer)
    declare property Enabled as Integer
    declare property Enabled(value as Integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as Integer
    declare property Height(value as Integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as Integer
    declare property Left(value as Integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as Integer
    declare property ShowHint(value as Integer)
    declare property Top as Integer
    declare property Top(value as Integer)
    declare property Visible as Integer
    declare property Visible(value as Integer)
    declare property Width as Integer
    declare property Width(value as Integer)
    declare property Wordwrap as Integer
    declare property Wordwrap(value as Integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub Update
    onClick    as sub(byref Sender as TStaticText)
    onDblClick as sub(byref Sender as TStaticText)
end type
