'*******************************************************************************
'*                           TStatusBar.bi                                     *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                           version 2.0                                       *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TStatusBarClass
       #define TStatusBarClass(__Ptr__) *cast(TStatusBar Ptr,__Ptr__)
#endif

#ifndef GetStatusBar
       #define GetStatusBar(__HWND__) *cast(TStatusBar Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PStatusBar as TStatusBar ptr
type TStatusPanel
    private:
    FWidth     as integer
    FAlignment as integer
    FBevel     as integer
    FText      as string
    public:
    StatusBar  as PStatusBar
    declare property Bevel as integer
    declare property Bevel(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Alignment as integer
    declare property Alignment(value as integer)
    declare property Text as string
    declare property Text(value as string)
    declare constructor(AWidth as integer=50,Alignment as integer=0,byref AText as string="")
    declare destructor
End type

type TStatusBar
    private:
    AControl as TControl = TControl("TStatusBar","msctls_statusbar32")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare Static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    FSimpleText  as string
    FSimplePanel as integer
    FCount       as integer
    FPanels      as TStatusPanel ptr ptr
    public:
    Font         as TFont
    PopupMenu    as TPopupMenu
    Cursor       as TCursor
    Tag          as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string = "TStatusBar",ClassAncestor as string = "msctls_statusbar32")
    declare sub UpdatePanels
    declare sub Add
    declare sub Remove(AIndex as integer)
    declare sub Clear
    declare property Panels(index as Integer) as TStatusPanel ptr
    declare property Panels(index as Integer,value as TStatusPanel ptr)
    declare property SimplePanel as Integer
    declare property SimplePanel(value as Integer)
    declare property SimpleText as string
    declare property SimpleText(value as string)
    declare property Count as Integer
    declare property Count(value as Integer)
    declare property Align as Integer
    declare property Align(value as Integer)
    declare property ClientHeight as Integer
    declare property ClientHeight(value as Integer)
    declare property ClientWidth as Integer
    declare property ClientWidth(value as Integer)
    declare property Color as Integer
    declare property Color(value as Integer)
    declare property Enabled as Integer
    declare property Enabled(value as Integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as Integer
    declare property Height(value as Integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as Integer
    declare property Left(value as Integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as Integer
    declare property ShowHint(value as Integer)
    declare property Top as Integer
    declare property Top(value as Integer)
    declare property Visible as Integer
    declare property Visible(value as Integer)
    declare property Width as Integer
    declare property Width(value as Integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
end type
