'*******************************************************************************
'*                           TTabControl.bi                                        *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                           version 2.0                                       *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TTabControlClass
#define TTabControlClass(__Ptr__) *cast(TTabControl Ptr,__Ptr__)
#endif

#ifndef GetTabControl
#define GetTabControl(__HWND__) *cast(TTabControl Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PTabControl as TTabControl ptr
type TTabControl
    private:
    AControl as TControl=TControl("TTabControl","SysTabControl32")
    declare sub DispatchMessage(byref Message as TMessage)
    declare sub ProcessMessage(byref Message as TMessage)
    declare sub MsgDefault(byref Message as TMessage)
    declare static function WindowProc(FWindow as hwnd,Msg as uint,wparam as wParam,lparam as lParam) as LResult
    FFlatButtons as integer
    FButtonStyle as integer
    FHotTrack    as integer
    FMultiline   as integer
    FTabPosition as integer
    FTabSize     as integer 
    FStyle       as integer 
    FTabIndex    as integer
    FCount       as integer
    FTabData     as any ptr ptr
    FTabs        as zstring ptr ptr
    public:
    Images       as TImageList
    Cursor       as TCursor
    Font         as TFont
    PopupMenu    as TPopupMenu
    Tag          as any ptr
    declare sub Add(value as string,valuedata as any ptr=0,imageindex as integer=-1)
    declare sub Insert(index as integer,value as string,valuedata as any ptr=0,imageindex as integer=-1)
    declare sub Remove(index as integer)
    declare sub Clear
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static sub RegisterClass(ClassName as string="TTabControl",ClassAncestor as string="SysTabControl32")
    declare property Tab(index as integer) as string
    declare property Tab(index as integer,value as string)
    declare property TabData(index as integer) as any ptr
    declare property TabData(index as integer,value as any ptr)
    declare property TabIndex as integer
    declare property TabIndex(value as integer)
    declare property Count as integer
    declare property Count(value as integer)
    declare property Style as integer
    declare property Style(value as integer)
    declare property HotTrack as integer
    declare property HotTrack(value as integer)
    declare property TabSize as integer
    declare property TabSize(value as integer)
    declare property Multiline as integer
    declare property Multiline(value as integer)
    declare property TabPosition as integer
    declare property TabPosition(value as integer)
    declare property ButtonStyle as integer
    declare property ButtonStyle(value as integer)
    declare property FlatButtons as integer
    declare property FlatButtons(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Color as integer
    declare property Color(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as string
    declare property Hint(value as string)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property TabOrder as integer
    declare property TabOrder(value as integer)
    declare property TabStop as integer
    declare property TabStop(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub BringToFront
    declare sub ClientToScreen(byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    declare sub Change
    onChange   as sub(byref Sender as TTabControl)
    onChanging as sub(byref Sender as TTabControl,byref AllowChange as integer)
    onDrawItem as sub(byref Sender as TTabControl,ItemID as integer,State as integer,R as Rect,Dc as hdc)
end type
