'*******************************************************************************
'*                           TToolBar.bi                                       *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                           version 2.0                                       *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TToolBarClass
#define TToolBarClass(__Ptr__) *cast(TToolBar Ptr,__Ptr__)
#endif

#ifndef GetToolBar
#define GetToolBar(__HWND__) *cast(TToolBar Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

#ifndef tbn_dropdown
#Define tbn_dropdown (tbn_first - 10)
#endif

type PToolBar as TToolBar ptr

type PToolButton as TToolButton ptr
type TToolButton
    private:
    FCaption     as string
    FImageIndex  as integer
    FHint        as string
    FShowHint    as integer
    FEnabled     as integer
    FVisible     as integer
    FStyle       as integer
    FDown        as integer
    FParent      as PToolBar
    public:
    DropDownMenu as TPopupMenu
    Tag          as any ptr
    declare constructor(AParent as PToolBar=0,AImageIndex as integer=-1,AEnabled as integer=1,AVisible as integer=1,ACaption as string="",AHint as string="",AShowHint as integer=0)
    declare destructor
    declare operator cast as any ptr
    declare operator cast as string
    declare property Parent as PToolBar
    declare property Parent(value as PToolBar)
    declare property Caption as string
    declare property Caption(value as string)
    declare property Hint as string
    declare property Hint(value as string)
    declare property Down as integer
    declare property Down(value as integer)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Style as integer
    declare property Style(value as integer)
    declare property ImageIndex as integer
    declare property ImageIndex(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare sub Click
    onClick as sub(byref Sender as TToolButton)
end type

type TToolBar
    private:
    AControl        as TControl = TControl("TToolBar","ToolBarWindow32")
    FImages         as TImageList
    FDisabledimages as TImageList
    FHotimages      as TImageList
    FFlat           as integer
    FAutosize       as integer
    FWrapable       as integer
    FButtonCount    as integer
    FButtons        as TToolButton ptr ptr
    declare sub DispatchMessage(byref Message as TMessage)
    declare sub ProcessMessage(byref Message as TMessage)
    declare sub MsgDefault(byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    public:
    Cursor          as TCursor 
    Font            as TFont
    Tag             as any ptr
    declare sub Add(value as TToolButton ptr)
    declare sub Insert(index as integer,value as TToolButton ptr)
    declare sub Remove(value as TToolButton ptr)
    declare function IndexOf(value as TToolButton ptr) as integer
    declare sub Clear
    declare sub Autosize
    declare constructor
    declare destructor
    declare operator cast as TControl ptr
    declare operator cast as any ptr
    declare operator cast as string
    declare property Images as TImageList
    declare property Images(value as TImageList)
    declare property DisabledImages as TImageList
    declare property DisabledImages(value as TImageList)
    declare property HotImages as TImageList
    declare property HotImages(value as TImageList)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property ButtonCount as integer
    declare property ButtonCount(value as integer)
    declare property Button(index as integer) as TToolButton ptr
    declare property Button(index as integer,value as TToolButton ptr)
    declare property Flat as integer
    declare property Flat(value as integer)
    declare property Wrapable as integer
    declare property Wrapable(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare static sub RegisterClass(AClassName as string = "TToolBar",AClassAncestor as string = "ToolBarWindow32")
    declare Sub BringToFront
    declare Sub ClientToScreen(Byref P as Point)
    declare Sub Invalidate
    declare Sub Repaint
    declare Sub ScreenToClient(Byref P as Point)
    declare Sub SendToBack
    declare Sub SetFocus
    declare Sub Update
    onButtonClick as sub(byref Sender as TToolBar,ButtonID as integer)
    onCommand     as sub(byref Sender as TToolbar,id as integer,code as integer)
    onClick       as sub(byref Sender as TToolbar)
    onDblClick    as sub(byref Sender as TToolbar)
end type
