'*******************************************************************************
'*                             TTrackBar.bi                                    *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef TTrackBarClass
       #define TTrackBarClass(__Ptr__) *Cast(TTrackBar ptr,__Ptr__)
#endif

#ifndef GetTrackBar
       #define GetTrackBar(__HWND__) *Cast(TTrackBar Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PTrackBar as TTrackBar ptr
type TTrackBar
    private:
    AControl as TControl = TControl("TTrackBar","msctls_trackbar32")
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    declare sub SetRanges(APosition as integer,AMin as integer,AMax as integer)
    FPosition       as integer
    FMinValue       as integer
    FMaxValue       as integer
    FTick           as integer 
    FTickMarks      as integer
    FTickStyle      as integer
    FLineSize       as integer
    FPageSize       as integer
    FThumbLength    as integer
    FFrequency      as integer
    FSelStart       as integer
    FSelEnd         as integer
    FSliderVisible  as integer
    FOrientation    as integer
    FFixedlength    as integer
    FEnableSelrange as integer
    public:
    Cursor          as TCursor
    Font            as TFont
    PopupMenu       as TPopupMenu
    Tag             as any ptr
    declare Constructor
    declare Destructor
    declare Operator cast as any ptr
    declare Operator cast as TControl ptr
    declare Operator cast as string
    declare static sub RegisterClass(ClassName as string = "TTrackBar",ClassAncestor as string = "msctls_trackbar32")
    declare Property MinValue as integer
    declare Property MinValue(Value as integer)
    declare Property MaxValue as integer
    declare Property MaxValue(Value as integer)
    declare Property Position  as integer
    declare Property Position(Value as integer)
    declare Property LineSize  as integer
    declare Property LineSize(Value as integer)
    declare Property PageSize  as integer
    declare Property PageSize(Value as integer)
    declare Property Frequency as integer
    declare Property Frequency(Value as integer)
    declare Property ThumbLength  as integer
    declare Property ThumbLength(Value as integer)
    declare Property SelStart  as integer
    declare Property SelStart(Value as integer)
    declare Property SelEnd as integer
    declare Property SelEnd(Value as integer)
    declare Property SliderVisible As Boolean
    declare Property SliderVisible(Value As Boolean)
    declare Property Tick as integer
    declare Property Tick(Value as integer)
    declare Property TickStyle as integer
    declare Property TickStyle(Value as integer)
    declare Property TickMarks as integer
    declare Property TickMarks(Value as integer)
    declare Property Orientation as integer
    declare Property Orientation(Value as integer)
    declare Property FixedLength as integer
    declare Property FixedLength(Value as integer)
    declare Property EnableSelRange as integer
    declare Property EnableSelRange(Value as integer)
    declare Property Align as integer
    declare Property Align(value as integer)
    declare Property ClientHeight as integer
    declare Property ClientHeight(value as integer)
    declare Property ClientWidth as integer
    declare Property ClientWidth(value as integer)
    declare Property Color as integer
    declare Property Color(value as integer)
    declare Property Enabled as integer
    declare Property Enabled(value as integer)
    declare Property Handle as hwnd
    declare Property Handle(value as hwnd)
    declare Property Height as integer
    declare Property Height(value as integer)
    declare Property Hint as String
    declare Property Hint(value as String)
    declare Property Left as integer
    declare Property Left(value as integer)
    declare Property Parent as TControl ptr
    declare Property Parent(value as TControl ptr)
    declare Property ShowHint as integer
    declare Property ShowHint(value as integer)
    declare Property Top as integer
    declare Property Top(value as integer)
    declare Property Visible as integer
    declare Property Visible(value as integer)
    declare Property Width as integer
    declare Property Width(value as integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    onChange as sub(Byref Sender as TTrackBar,Position as integer)
end type
