'*******************************************************************************
'*                             TUpDown.bi                                      *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "graphics.bi"
#include once "menus.bi"

#ifndef UDN_DELTAPOS
       Const UDN_DELTAPOS = (UDN_FIRST - 1)
#endif

#ifndef TUpDownClass
       #define TUpDownClass(__Ptr__) *Cast(TUpDown ptr,__Ptr__)
#endif

#ifndef GetUpDown
       #define GetUpDown(__HWND__) *Cast(TUpDown Ptr,GetWindowLong(__HWND__,GetClassLong(__HWND__,gcl_cbwndextra)-4))
#endif

type PUpDown as TUpDown ptr
type TUpDown
    private:
    AControl       as TControl = TControl("TUpDown","msctls_UpDown32")
    FPosition      as integer
    FMinValue      as integer
    FMaxValue      as integer=100
    FArrowKeys     as integer
    FIncrement     as integer=1
    FAlignment     as integer
    FThousands     as integer
    FWrap          as integer
    FAssociate     as TControl Ptr
    FOrientation   as integer
    FUDAccel(1)    as UDACCEL
    declare sub DispatchMessage(Byref Message as TMessage)
    declare sub ProcessMessage(Byref Message as TMessage)
    declare sub MsgDefault(Byref Message as TMessage)
    declare static function WindowProc(fWindow as hWnd,msg as UInt,wparam as wParam,lparam as lParam) as LResult
    declare sub SetRange(AMin as integer,AMax as integer)
    public:
    Font           as TFont
    PopupMenu      as TPopupMenu
    Cursor         as TCursor
    Tag            as any ptr
    declare constructor
    declare destructor
    declare operator cast as any ptr
    declare operator cast as TControl ptr
    declare operator cast as string
    declare static Sub RegisterClass(ClassName as string = "TUpDown",ClassAncestor as string = "msctls_UpDown32")
    declare property MinValue as integer
    declare property MinValue(Value as integer)
    declare property MaxValue as integer
    declare property MaxValue(Value as integer)
    declare property Increment as integer
    declare property Increment(Value as integer)
    declare property Position  as integer
    declare property Position(Value as integer)
    declare property ArrowKeys as integer
    declare property ArrowKeys(Value as integer)
    declare property Thousands as integer
    declare property Thousands(Value as integer)
    declare property Wrap as integer
    declare property Wrap(Value as integer)
    declare property Associate as TControl Ptr
    declare property Associate(Value as TControl Ptr)
    declare property Orientation as integer
    declare property Orientation(value as integer)
    declare property Align as integer
    declare property Align(value as integer)
    declare property ClientHeight as integer
    declare property ClientHeight(value as integer)
    declare property ClientWidth as integer
    declare property ClientWidth(value as integer)
    declare property Enabled as integer
    declare property Enabled(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare property Height as integer
    declare property Height(value as integer)
    declare property Hint as String
    declare property Hint(value as String)
    declare property Left as integer
    declare property Left(value as integer)
    declare property Parent as TControl ptr
    declare property Parent(value as TControl ptr)
    declare property ShowHint as integer
    declare property ShowHint(value as integer)
    declare property Top as integer
    declare property Top(value as integer)
    declare property Visible as integer
    declare property Visible(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare sub BringToFront
    declare sub ClientToScreen(Byref P as Point)
    declare sub Invalidate
    declare sub Repaint
    declare sub ScreenToClient(Byref P as Point)
    declare sub SendToBack
    declare sub SetFocus
    declare sub Update
    onChanging as sub(Byref Sender as TUpDown,Value as integer,Direction as integer)
end type
